
<section>
  <div class="container m-auto">
    <h2>Purpose</h2>
    <p>SEO is hard. Solve most of your SEO woes with a drop-in and go solution.</p>
    <p>@ripp/SEO seeks to provide common mappings of social media, search-engine, and other meta tags with the ability to drive them a simple context object.</p>
    <p class="mt-4 text-left">For example, providing a context of:</p>
    <pre class="text-left"><code>const newContext = &lbrace; title: "Page Title", description: "It's a pretty neat page" &rbrace;;</code></pre>
    <p class="mt-4 text-left">Will produce:</p>
    <pre class="text-left"><code>&lt;title&gt;Page Title&lt;/title&gt;
&lt;meta property="og:title" content="Page Title"&gt;
&lt;meta property="twitter:title" content="Page Title"&gt;
&lt;meta name="description" content="It's a pretty neat page"&gt;
&lt;meta property="og:description" content="It's a pretty neat page"&gt;
&lt;meta property="twitter:description" content="It's a pretty neat page"&gt;
&lt;meta name="robots" content="index, follow"&gt;          &lt;!-- default --&gt;
&lt;link rel="canonical" href="http://localhost:4200/"&gt;  &lt;!-- defaults to current URL on call to update --&gt;
&lt;meta property="og:url" content="http://localhost:4200/"&gt;
&lt;meta property="twitter:url" content="http://localhost:4200/"&gt;</code></pre>
  </div>
</section>
<section>
  <div class="container m-auto">
    <h2>Get Started</h2>
    <p></p>
    <div class="flex flex-wrap gap-1 justify-evenly instructions">
      <div>
        <div>
          <h3>Plain JS/TS</h3>
          <h4>Install</h4>
          <pre><code>npm i -S @ripp/seo</code></pre>
          <h4>Setup</h4>
          <pre><code>import &lbrace; SeoManager &rbrace; from '@ripp/seo';

const seoManager = new SeoManager();</code></pre>
          <h4>Use</h4>
          <p>Perform updates to SEO, likely on navigation changes</p>
          <pre><code>const newContext = &lbrace; title: "Page Title" &rbrace;;

seoManager.update(newContext);</code></pre>
        </div>
      </div>
      <div>
        <div>
          <h3>Angular</h3>
          <h4>Install</h4>
          <pre><code>ng add @ripp/seo</code></pre>
          <h4>Setup <small>(<code>ng add</code> will set this up)</small></h4>
          <pre><code>import &lbrace; SeoModule &rbrace; from '@ripp/seo/ng';

...
@NgModule(&lbrace;
  ...
  imports: [
    ...
    SeoModule,
  ],
  ...
&rbrace;)
export class AppModule &lbrace; &rbrace;</code></pre>
          <h4>Use</h4>
          <p>By default a route listener is registered, calling update with<br>SEO context found on route <code>data.seo</code> or component static<br>field <code>MyComponent.SEO</code></p>
          <pre><code>import &lbrace; SeoService &rbrace; from '@ripp/seo/ng';

...
  constructor(private seoService: SeoService) &lbrace;&rbrace;

  onAction() &lbrace;
    const newContext = &lbrace; title: "Page Title" &rbrace;;
    this.seoService.update(context);
  &rbrace;
...</code></pre>
        </div>
      </div>
    </div>
  </div>
</section>
<section>
  <div class="container m-auto">
    <h2>Sandbox</h2>
    <p class="mb-4">Experiment with a Live-editor <a routerLink="sandbox">Sandbox</a> to see what tags and values will be produced.</p>
    <a routerLink="sandbox" mat-flat-button color="primary">Play in the Sandbox</a>
  </div>
</section>
